=== added directory 'prebuilt'
=== added directory 'prebuilt/meta'
=== added directory 'prebuilt/meta/hooks'
=== added file 'prebuilt/meta/hooks/configure'
--- prebuilt/meta/hooks/configure	1970-01-01 00:00:00 +0000
+++ prebuilt/meta/hooks/configure	2017-01-06 09:51:21 +0000
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+if path=$(snapctl get ubx::provider::path); then
+    mkdir -p $SNAP_DATA/ubx/provider
+    echo "$path" > $SNAP_DATA/ubx/provider/path
+fi

=== modified file 'snapcraft.yaml'
--- snapcraft.yaml	2016-12-09 10:49:29 +0000
+++ snapcraft.yaml	2017-01-06 09:51:21 +0000
@@ -42,6 +42,9 @@
         interface: serial-port
 
 parts:
+  hooks:
+    plugin: dump
+    source: prebuilt          
   location-service:
     plugin: cmake
     configflags:

=== modified file 'src/location/providers/ubx/provider.cpp'
--- src/location/providers/ubx/provider.cpp	2016-12-12 13:01:34 +0000
+++ src/location/providers/ubx/provider.cpp	2017-01-06 09:51:21 +0000
@@ -21,8 +21,12 @@
 #include <location/logging.h>
 #include <location/runtime.h>
 
+#include <core/posix/this_process.h>
+
+#include <fstream>
 #include <thread>
 
+namespace env = core::posix::this_process::env;
 namespace ubx = location::providers::ubx;
 
 std::string ubx::Provider::class_name()
@@ -100,7 +104,12 @@
 
 location::Provider::Ptr ubx::Provider::create_instance(const location::ProviderFactory::Configuration& config)
 {
-    return location::Provider::Ptr{new ubx::Provider{config.get<std::string>("device", "/dev/ttyS4")}};
+    std::string device_path;
+    std::ifstream in(env::get("SNAP_DATA") + "/ubx/provider/path");
+
+    in >> device_path;
+
+    return location::Provider::Ptr{new ubx::Provider{config.get<std::string>("device", device_path.empty() ? "/dev/ttyS4" : device_path)}};
 }
 
 ubx::Provider::Provider(const boost::filesystem::path& device)

